import 'dart:async';

import 'package:witsystem_device_plugin/device/DeviceManage.dart';

import 'WitsystemSDK.dart';

//BasicMessageChannel
class WitsystemDevicePlugin extends WisystemSDk {
  factory WitsystemDevicePlugin() => _getInstance();

  static WitsystemDevicePlugin get instance => _getInstance();
  static WitsystemDevicePlugin? _instance;

  WitsystemDevicePlugin._internal();

  static WitsystemDevicePlugin _getInstance() {
    _instance ??= WitsystemDevicePlugin._internal();
    return _instance!;
  }

  /// 初始化SDK
  Future<bool> initSDK(String appId, token, appSecret, rsaPrivateKey) async {
    final map = {
      "appId": appId,
      "token": token,
      "appSecret": appSecret,
      "rsaPrivateKey": rsaPrivateKey
    };
    return await methodChannel.invokeMethod("initSDK", map);
  }

  ///取消初始化
  uninitDevices() async {
    DeviceManage().removeDeviceChangeObserver();//移除所有的观察者
    return await methodChannel.invokeMethod("uninitDevices");
  }
}
